-- Read the weapon_real_base if you really want to know what each action does.
-- Read the weapon_real_cs_pumpshotgun if you really want to know how shotguns work.

if (SERVER) then
	AddCSLuaFile("shared.lua")
	SWEP.HoldType = "ar2"
end

if (CLIENT) then
	SWEP.PrintName 		= "Double Barrel Shotgun"
	SWEP.ViewModelFlip	= false
        SWEP.Slot 			= 3
	SWEP.SlotPos 		= 1
	SWEP.IconLetter 		= "B"

	killicon.AddFont("weapon_real_cs_xm1014", "CSKillIcons", SWEP.IconLetter, Color( 255, 80, 0, 255 ))
end

/*---------------------------------------------------------
Muzzle Effect + Shell Effect
---------------------------------------------------------*/
SWEP.MuzzleEffect			= "none" -- This is an extra muzzleflash effect
-- Available muzzle effects: rg_muzzle_grenade, rg_muzzle_highcal, rg_muzzle_hmg, rg_muzzle_pistol, rg_muzzle_rifle, rg_muzzle_silenced, none

SWEP.ShellEffect			= "rg_shelleject_shotgun" -- This is a shell ejection effect
-- Available shell eject effects: rg_shelleject, rg_shelleject_rifle, rg_shelleject_shotgun, none

SWEP.MuzzleAttachment		= "1" -- Should be "1" for CSS models or "muzzle" for hl2 models
SWEP.ShellEjectAttachment	= "2" -- Should be "2" for CSS models or "1" for hl2 models

SWEP.EjectDelay			= 0.1
/*-------------------------------------------------------*/

SWEP.Instructions 		= "Shoot Stuff"

SWEP.Base 				= "weapon_real_cs_pumpshotgun"
SWEP.Category				= "Mafia Sweps"

SWEP.Spawnable 			= true
SWEP.AdminSpawnable 		= true

SWEP.ViewModel 			= "models/weapons/v_shot_xm1011.mdl"
SWEP.WorldModel 			= "models/weapons/w_shot_xm1011.mdl"

SWEP.Primary.Sound 		= Sound("Weapon_Barell.Single")
SWEP.Primary.Recoil 		= 0.02
SWEP.Primary.Damage 		= 500
SWEP.Primary.NumShots 		= 12
SWEP.Primary.Cone 		= 0.075
SWEP.Primary.ClipSize 		= 2
SWEP.Primary.Delay 		= 0.25
SWEP.Primary.DefaultClip 	= 2
SWEP.Primary.Automatic 		= false
SWEP.Primary.Ammo 		= "buckshot"

SWEP.Secondary.ClipSize 	= -1
SWEP.Secondary.DefaultClip 	= -1
SWEP.Secondary.Automatic 	= false
SWEP.Secondary.Ammo 		= "none"

SWEP.IronSightsPos = Vector (-2.724, -4.5277, 0.948)
SWEP.IronSightsAng = Vector (2.4593, 0.3634, 0)

SWEP.data 				= {}
SWEP.mode 				= "auto"
SWEP.data.newclip 		= false

SWEP.data.semi 			= {}
SWEP.data.semi.Delay 		= .3
SWEP.data.semi.Cone 		= 0.015
SWEP.data.semi.NumShots 	= 1
SWEP.data.semi.Damage 		= 75

SWEP.data.auto 			= {}
SWEP.data.auto.Delay 		= .3
SWEP.data.auto.Cone 		= 0.075
SWEP.data.auto.NumShots 	= 12
SWEP.data.auto.Damage 		= 25

/*---------------------------------------------------------
Reload
---------------------------------------------------------*/
function SWEP:Reload()

	if ( self.Reloadaftershoot > CurTime() ) then return end

	self:SetIronsights(false)

	if (self.Weapon:GetNWBool("reloading", false)) or ShotgunReloading then return end

	if (self.Weapon:Clip1() < self.Primary.ClipSize and self.Owner:GetAmmoCount(self.Primary.Ammo) > 0) then
			ShotgunReloading = true
			self.Weapon:SetNextPrimaryFire(CurTime() + 0.5)
			self.Weapon:SetNextSecondaryFire(CurTime() + 0.5)
			self.Weapon:SendWeaponAnim(ACT_SHOTGUN_RELOAD_START)
		timer.Simple(0.5, function()
			ShotgunReloading = false
			self.Weapon:SetNetworkedBool("reloading", true)
			self.Weapon:SetVar("reloadtimer", CurTime() + 1)
			self.Weapon:SetNextPrimaryFire(CurTime() + 0.5)
			self.Weapon:SetNextSecondaryFire(CurTime() + 0.5)
		end)
	end
end