if SERVER then
	AddCSLuaFile( "shared.lua" )	
end

if ( CLIENT ) then

	SWEP.DrawAmmo			= true
	SWEP.DrawCrosshair		= false
	SWEP.ViewModelFOV		= 64
	SWEP.ViewModelFlip		= true
	SWEP.CSMuzzleFlashes		= true

end

SWEP.Slot		 = -1
SWEP.SlotPos		 = -1
SWEP.HoldType = "ar2"

SWEP.Base = "weapon_base"

SWEP.Spawnable		= true
SWEP.AdminSpawnable	= true

SWEP.Weight		= 5
SWEP.AutoSwitchTo	= false
SWEP.AutoSwitchFrom	= false

SWEP.ViewModel		= ""
SWEP.WorldModel		= ""

SWEP.AutoReload		= true

SWEP.Primary.ClipSize		= -1
SWEP.Primary.DefaultClip	= -1
SWEP.Primary.Automatic		= false
SWEP.Primary.Ammo		= "none"
SWEP.Primary.Delay		= 0
SWEP.Primary.Recoil	 	= 2
SWEP.Primary.Cone		= 0.08
SWEP.CrossHairScale         = 0.03

SWEP.Secondary.ClipSize		= -1
SWEP.Secondary.DefaultClip	= -1
SWEP.Secondary.Automatic	= false
SWEP.Secondary.Ammo		= "none"
SWEP.Secondary.Delay		= 0

SWEP.HitSound		= nil
SWEP.HitEffect		= nil

SWEP.SoundEmpty		= nil

SWEP.SoundDeploy	= nil
SWEP.AnimDeploy		= nil

SWEP.SprintPos = Vector (7.4355, -18.3718, -1.1893)
SWEP.SprintAng = Vector (-7.172, 60.486, 1.7106)

function SWEP:Initialize()
	self:SetWeaponHoldType( self.HoldType )
end	

function SWEP:DrawHUD()
	// No crosshair when ironsights is on
	if ( self.Weapon:GetNetworkedBool( "Ironsights" ) ) or self.ShowCrossHair == false then return end

	local x = ScrW() / 2.0
	local y = ScrH() / 2.0
	local scale = 10 * self.CrossHairScale
	if self.Owner:KeyDown(IN_FORWARD) or self.Owner:KeyDown(IN_BACK) or self.Owner:KeyDown(IN_MOVELEFT) or self.Owner:KeyDown(IN_MOVERIGHT) then
	scale = self.CrossHairScale * 15
	elseif self.Owner:KeyDown(IN_DUCK) or self.Owner:KeyDown(IN_WALK) then
	scale = math.Clamp( self.CrossHairScale*10 / 2, 0, 100 )
	end
	// Scale the size of the crosshair according to how long ago we fired our weapon
	local LastShootTime = self.Weapon:GetNetworkedFloat( "LastShootTime", 0 )
 surface.SetDrawColor( 0, 255, 0, 255)
	// Draw an awesome crosshair
	local gap = 15 * scale
	gap = gap * (2 - math.Clamp( (CurTime() - LastShootTime) * 5, 0.0, 1.0 ))
	local length = gap + 35 * scale
	surface.DrawLine( x - length, y, x - gap, y )
	surface.DrawLine( x + length, y, x + gap, y )
	surface.DrawLine( x, y - length, x, y - gap )
	surface.DrawLine( x, y + length, x, y + gap )
	if self.Weapon:GetNetworkedBool( "Scoped" ) == true then
	surface.SetTexture(surface.GetTextureID("gmod/scope"))
	surface.SetDrawColor(0,0,0,255)
	surface.DrawTexturedRect(0,0,ScrW(),ScrH())
	surface.SetDrawColor( 0, 0, 0, 255 )
	surface.DrawLine( 0, ScrH() / 2, ScrW(), ScrH() / 2)
	surface.DrawLine( ScrW() / 2, 0, ScrW() / 2, ScrH())
	end
	end

function SWEP:Reload()
	if self.Owner:GetAmmoCount( self.Primary.Ammo ) <= 0 || self.Weapon:Clip1() >= self.Primary.ClipSize then
		return
	end

	if self.SpecialReload && self:SpecialReload() then
		return
	end

	if self.SoundReload && IsFirstTimePredicted() then
		self:EmitSound( self.SoundReload )
	end

	self.Weapon:DefaultReload( ACT_VM_RELOAD )
	self.Owner:SetAnimation( PLAYER_RELOAD )
end

function SWEP:Deploy()
	if self.SoundDeploy && IsFirstTimePredicted() then
		self:EmitSound( self.SoundDeploy )
	end

	self:SendWeaponAnim( self.AnimDeploy or ACT_VM_DRAW )

	return true
end

function SWEP:PrimaryAttack()
	if !self:CanPrimaryAttack() then return true end

	self.Weapon:SetNextSecondaryFire( CurTime() + self.Primary.Delay )
	self.Weapon:SetNextPrimaryFire( CurTime() + self.Primary.Delay )

	self:ShootBullet(self.Primary.Damage, self.Primary.NumShots, self.Primary.Cone, self.Primary.Ammo)
	self:ShootEffects(self.Primary.Sound, self.Primary.Recoil, self.Primary.Effect, ACT_VM_PRIMARYATTACK)

	if self.Primary.UnlimAmmo then return end
	self:TakePrimaryAmmo( 1 )
end

function SWEP:SecondaryAttack()
	if !self:CanSecondaryAttack() then return true end

	self.Weapon:SetNextSecondaryFire( CurTime() + self.Secondary.Delay )
	self.Weapon:SetNextPrimaryFire( CurTime() + self.Secondary.Delay )
	
	self:ShootBullet(self.Secondary.Damage, self.Secondary.NumShots, self.Secondary.Cone, self.Primary.Ammo, self.Secondary.Effect)
	self:ShootEffects(self.Secondary.Sound, self.Secondary.Recoil, self.Primary.Effect, ACT_VM_SECONDARYATTACK)

	if self.Primary.UnlimAmmo then return end
	self:TakePrimaryAmmo( 1 )
end

function SWEP:RicochetCallback(att, tr, dmginfo, num)
	if CLIENT then return end
	if tr.HitNonWorld || tr.HitSky then return end

	local fx = EffectData()
		fx:SetOrigin( tr.HitPos )
		fx:SetNormal( tr.HitNormal )
	util.Effect( "StunstickImpact", fx, true )

	local fx = EffectData()
		fx:SetOrigin( tr.HitPos )
		fx:SetNormal( tr.HitNormal )
	util.Effect( "bulletsmoke", fx, true )

	if num > 6 then return end

	local DotProduct = tr.HitNormal:Dot( tr.Normal * -1 )

	local bullet = {}
	
	bullet.Num		= 1
	bullet.Src		= tr.HitPos
	bullet.Dir		= ( 2 * tr.HitNormal * DotProduct ) + tr.Normal
	bullet.Spread 		= Vector( 0, 0, 0 )
	bullet.Tracer		= 1
	bullet.TracerName 	= "ragingbull_trace"
	bullet.Force		= 1
	bullet.Damage		= math.random( 8, 10 )
	bullet.AmmoType		= self.Primary.Ammo
	bullet.Callback		= function( a, b, c )
		self:RicochetCallback( a, b, c, num + 1 )
	end

	timer.Simple( 0.03 * num, self.Owner.FireBullets, self.Owner, bullet )

end

function SWEP:BulletCallback(att, tr, dmginfo)
	if CLIENT then return end

	if IsValid(tr.Entity) && tr.Entity:IsPlayer() then

		if self.HitSound && IsFirstTimePredicted() then
			if type(self.HitSound) == "table" then
				local snd = self.HitSound[math.random(1,#self.HitSound)]
				self:EmitSound( snd )
				tr.Entity:EmitSound( snd )
			else
				self:EmitSound( self.HitSound )
				tr.Entity:EmitSound( self.HitSound )
			end
		end

		if self.HitEffect && IsFirstTimePredicted() then
			local hfx = EffectData()
				hfx:SetEntity( tr.Entity )
			util.Effect( self.HitEffect, hfx, true, true )
		end

	end
	
	if self.Ricochet then
		self:RicochetCallback(att, tr, dmginfo, 0)
	end
end

function SWEP:ShootMelee( dmg, hitworld_sound, hitply_sound, miss_sound )
	local mdmg = 0

	if type(dmg) == "table" then
		mdmg	= math.random(dmg[1],dmg[2])
	else
		mdmg	= dmg
	end

	self.Owner:LagCompensation( true )

	local trace = util.TraceHull({start=self.Owner:GetShootPos(),
			endpos=self.Owner:GetShootPos() + self.Owner:GetAimVector() * 50,
			mins=Vector(-8, -8, -8), maxs=Vector(8, 8, 8),
			filter=self.Owner})

	self.Owner:LagCompensation( false )

	local sound = miss_sound

	if trace.Hit then
		if IsValid(trace.Entity) && trace.Entity:IsPlayer() then
			sound = hitply_sound
		else
			sound = hitworld_sound
		end

		self:DecalForTrace( trace )
	end

	if sound && IsFirstTimePredicted() then
		if type(sound) == "table" then
			self.Weapon:EmitSound( sound[math.random(1, #sound)] )
		else
			self.Weapon:EmitSound( sound )
		end
	end

	self.Weapon:SendWeaponAnim( ACT_VM_HITCENTER )
	self.Owner:SetAnimation( PLAYER_ATTACK1 )

	if SERVER && IsValid(trace.Entity) then
		local bdmg = 0

		if type(dmg) == "table" then
			bdmg	= math.random(dmg[1],dmg[2])
		else
			bdmg	= dmg
		end

		trace.Entity:TakeDamage(bdmg, self.Owner)
	end
end

function SWEP:DecalForTrace( trace )
	local mat = trace.MatType

	local decal = nil
		
	if mat == MAT_FLESH then
		decal = "Impact.Flesh"
		local effectdata = EffectData()
			effectdata:SetOrigin(trace.HitPos)
			effectdata:SetStart(trace.HitPos + trace.HitNormal * 8)
		util.Effect("BloodImpact", effectdata)
	elseif mat == MAT_ANTLION then
		decal = "Impact.Antlion"
	elseif mat == MAT_BLOODYFLESH then
		decal = "Impact.BloodyFlesh"
		local effectdata = EffectData()
			effectdata:SetOrigin(trace.HitPos)
			effectdata:SetStart(trace.HitPos + trace.HitNormal * 8)
		util.Effect("BloodImpact", effectdata)
	elseif mat == MAT_SLOSH then
		decal = "Impact.BloodyFlesh"
	elseif mat == MAT_ALIENFLESH then
		decal = "Impact.AlienFlesh"
	elseif mat == MAT_WOOD then
		decal = "Impact.Concrete"
	elseif mat == MAT_CONCRETE then
		decal = "Impact.Concrete"
	elseif mat == MAT_METAL then
		decal = "Impact.Concrete"
	elseif mat == MAT_SAND or mat == MAT_DIRT or mat == MAT_FOLIAGE then
		decal = "Impact.Concrete"
	elseif mat == MAT_GLASS then
		decal = "Impact.Glass"
	elseif mat == MAT_VENT or mat == MAT_GRATE then
		decal = "Impact.Metal"
	elseif mat == MAT_PLASTIC then
		decal = "Impact.Metal"
	elseif mat == MAT_COMPUTER then
		decal = "Impact.Metal"
	elseif mat == MAT_TILE then
		decal = "Impact.Concrete"
	end

	if decal then
		util.Decal(decal, trace.HitPos + trace.HitNormal * 8, trace.HitPos - trace.HitNormal * 8)
	end
end

function SWEP:ShootEnt( class, force )
	if CLIENT then return end

	local ent = ents.Create( class )
	if IsValid(ent) then

		ent:SetPos( self.Owner:GetShootPos() )
		ent:SetOwner( self.Owner )
		ent:SetPhysicsAttacker( self.Owner ) 
		ent:Spawn()
		ent:Activate()

		local phys = ent:GetPhysicsObject()
		if IsValid(phys) then
			phys:SetVelocity( self.Owner:GetVelocity() + (self.Owner:GetAimVector() * force) )
		end

	end

end

function SWEP:ShootBullet( dmg, numbul, cone, ammo )
	numbul 	= numbul 	or 1
	cone 	= cone 		or 0.01

	local bullet = {}
	bullet.Num 		= numbul
	bullet.Src 		= self.Owner:GetShootPos()
	bullet.Dir 		= self.Owner:GetAimVector()
	bullet.Spread 	= Vector( cone, cone, 0 )
	bullet.Tracer	= 1
	bullet.Force	= 1

	if type(dmg) == "table" then
		bullet.Damage	= math.random(dmg[1],dmg[2])
	else
		bullet.Damage	= dmg
	end

	if ammo != "none" then
		bullet.AmmoType	= ammo
	end

	bullet.Callback = function(att, tr, dmginfo)
		self:BulletCallback(att, tr, dmginfo)
	end
	
	self.Owner:FireBullets( bullet )
end

function SWEP:ShootEffects(sound, viewpunch, effect, anim)
	if sound && IsFirstTimePredicted() then
		if type(sound) == "table" then
			self.Weapon:EmitSound( sound[math.random(1, #sound)] )
		else
			self.Weapon:EmitSound( sound )
		end
	end

	if viewpunch then
		self.Owner:ViewPunch( Angle( math.Rand(-0.2,-0.1) * viewpunch, 0, 0 ) )
	end

	if effect && IsFirstTimePredicted() then
		local tr = self.Owner:GetEyeTrace()
		local effectdata = EffectData()
			effectdata:SetOrigin( tr.HitPos )
			effectdata:SetStart( self.Owner:GetShootPos() + Vector( 0, 5, 0 ) )
			effectdata:SetAttachment( 1 )
			effectdata:SetEntity( self )
		util.Effect( effect, effectdata )
	end

	self.Weapon:SendWeaponAnim( anim or ACT_VM_PRIMARYATTACK )
	self.Owner:MuzzleFlash()
	self.Owner:SetAnimation( PLAYER_ATTACK1 )
end

function SWEP:CanPrimaryAttack()
	if self.Weapon:Clip1() == 0 then
		if self.SoundEmpty && IsFirstTimePredicted() then
			if type(self.SoundEmpty) == "table" then
				self:EmitSound( self.SoundEmpty[math.random(1,#self.SoundEmpty)] )
			else
				self:EmitSound( self.SoundEmpty )
			end
		end

		self:SetNextPrimaryFire( CurTime() + self.Primary.Delay )

		if self.AutoReload then self:Reload() end
		return false
	else
		return true
	end
end

SWEP.CanSecondaryAttack = SWEP.CanPrimaryAttack